// Code generated by mdatagen. DO NOT EDIT.

package metadata

import "go.opentelemetry.io/collector/confmap"

// MetricConfig provides common config for a particular metric.
type MetricConfig struct {
	Enabled bool `mapstructure:"enabled"`

	enabledSetByUser bool
}

func (ms *MetricConfig) Unmarshal(parser *confmap.Conf) error {
	if parser == nil {
		return nil
	}
	err := parser.Unmarshal(ms, confmap.WithErrorUnused())
	if err != nil {
		return err
	}
	ms.enabledSetByUser = parser.IsSet("enabled")
	return nil
}

// MetricsConfig provides config for k8s/node metrics.
type MetricsConfig struct {
	K8sNodeAllocatableCPU              MetricConfig `mapstructure:"k8s.node.allocatable_cpu"`
	K8sNodeAllocatableEphemeralStorage MetricConfig `mapstructure:"k8s.node.allocatable_ephemeral_storage"`
	K8sNodeAllocatableMemory           MetricConfig `mapstructure:"k8s.node.allocatable_memory"`
	K8sNodeAllocatableStorage          MetricConfig `mapstructure:"k8s.node.allocatable_storage"`
	K8sNodeConditionDiskPressure       MetricConfig `mapstructure:"k8s.node.condition_disk_pressure"`
	K8sNodeConditionMemoryPressure     MetricConfig `mapstructure:"k8s.node.condition_memory_pressure"`
	K8sNodeConditionNetworkUnavailable MetricConfig `mapstructure:"k8s.node.condition_network_unavailable"`
	K8sNodeConditionPidPressure        MetricConfig `mapstructure:"k8s.node.condition_pid_pressure"`
	K8sNodeConditionReady              MetricConfig `mapstructure:"k8s.node.condition_ready"`
}

func DefaultMetricsConfig() MetricsConfig {
	return MetricsConfig{
		K8sNodeAllocatableCPU: MetricConfig{
			Enabled: true,
		},
		K8sNodeAllocatableEphemeralStorage: MetricConfig{
			Enabled: true,
		},
		K8sNodeAllocatableMemory: MetricConfig{
			Enabled: true,
		},
		K8sNodeAllocatableStorage: MetricConfig{
			Enabled: true,
		},
		K8sNodeConditionDiskPressure: MetricConfig{
			Enabled: true,
		},
		K8sNodeConditionMemoryPressure: MetricConfig{
			Enabled: true,
		},
		K8sNodeConditionNetworkUnavailable: MetricConfig{
			Enabled: true,
		},
		K8sNodeConditionPidPressure: MetricConfig{
			Enabled: true,
		},
		K8sNodeConditionReady: MetricConfig{
			Enabled: true,
		},
	}
}

// ResourceAttributeConfig provides common config for a particular resource attribute.
type ResourceAttributeConfig struct {
	Enabled bool `mapstructure:"enabled"`
}

// ResourceAttributesConfig provides config for k8s/node resource attributes.
type ResourceAttributesConfig struct {
	K8sNodeName            ResourceAttributeConfig `mapstructure:"k8s.node.name"`
	K8sNodeUID             ResourceAttributeConfig `mapstructure:"k8s.node.uid"`
	OpencensusResourcetype ResourceAttributeConfig `mapstructure:"opencensus.resourcetype"`
}

func DefaultResourceAttributesConfig() ResourceAttributesConfig {
	return ResourceAttributesConfig{
		K8sNodeName: ResourceAttributeConfig{
			Enabled: true,
		},
		K8sNodeUID: ResourceAttributeConfig{
			Enabled: true,
		},
		OpencensusResourcetype: ResourceAttributeConfig{
			Enabled: true,
		},
	}
}

// MetricsBuilderConfig is a configuration for k8s/node metrics builder.
type MetricsBuilderConfig struct {
	Metrics            MetricsConfig            `mapstructure:"metrics"`
	ResourceAttributes ResourceAttributesConfig `mapstructure:"resource_attributes"`
}

func DefaultMetricsBuilderConfig() MetricsBuilderConfig {
	return MetricsBuilderConfig{
		Metrics:            DefaultMetricsConfig(),
		ResourceAttributes: DefaultResourceAttributesConfig(),
	}
}
